Subject: [PATCH] ARM: imx6: initialize CCM_CLPCR_LPM into RUN mode earlier

From: [email-masked] (Shawn Guo)
Date: Thu, 30 Apr 2015 23:25:49 +0800

On Wed, Apr 29, 2015 at 01:43:39PM -0700, Tyler Baker wrote:
> On 28 April 2015 at 22:58, Shawn Guo <[email-masked]> wrote:
> > Commit 4631960d26da ("ARM: imx6: set initial power mode in pm function")
> > moves imx6_set_lpm() from clock init function into
> > imx6_pm_common_init().  This causes a hang when cpuidle support is
> > enabled.  The reason for that is ARM core clock is shut down
> > unexpectedly by WAIT mode.  It happens with the following call stack:
> >
> >     cpuidle_register_governor()
> >         cpuidle_switch_governor()
> >             cpuidle_uninstall_idle_handler()
> >                 synchronize_sched()
> >                     wait_rcu_gp()
> >                         wait_for_completion()
> >
> > When wait_for_completion() is called as above, all cores are idle/WFI.
> > Hence, the reset value of CCM_CLPCR_LPM - WAIT mode, will trigger a
> > hardware shutdown of the ARM core clock.
> >
> > To fix the regression, we need to ensure that CCM_CLPCR_LPM is
> > initialized into RUN mode earlier than cpuidle governor registration,
> > which is a postcore_initcall.  This patch creates function
> > imx6_pm_ccm_init() to map CCM block and initialize CCM_CLPCR_LPM into
> > RUN mode, and have the function called from machine .init_irq hook,
> > which should be early enough.
> >
> > Reported-by: Kevin Hilman <[email-masked]>
> > Fixes: 4631960d26da ("ARM: imx6: set initial power mode in pm function")
> > Signed-off-by: Shawn Guo <[email-masked]>
> 
> Tested-by: Tyler Baker <[email-masked]>
> 
> I have applied this patch on top of next-20150429[1] and build/boot
> tested it with the kernelci.org farm. With these results[2], I can
> confirm the IMX6 boot regression reported is fixed by this patch.

Thanks for testing, Tyler.  I added your test tag to the patch.

Shawn